function varargout=plotVal(self,u,varargin)
  p = inputParser;
  p.KeepUnmatched=true; 
  p.PartialMatching=false;
%  p.addParamValue('PlotOptions',{});
  p.addParamValue('plan',false);
  p.parse(varargin{:});
  R=p.Results;
  varargin=fc_tools.utils.deleteCellOptions(varargin,p.Parameters);
  global plan
  plan=R.plan;
  H=[];
  %H=eval(sprintf('PlotSubTh%dsimp%dD(self,u,R.PlotOptions)',self.d,self.dim));
  eval(sprintf('H=PlotSubTh%dsimp%dD(self,u,varargin);',self.d,self.dim));
  if nargout==1,varargout{1}=H;end
end

function h=PlotSubTh3simp3D(self,u,PlotOptions)
  %warning('PlotSubTh3simp3D not implemented')
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  view(3)
  idx=nchoosek(1:4,2);
  for i=1:size(idx,1)
    h(i)=patch('Vertices',self.q','Faces',self.me(idx(i,:),:)','CData',U,'EdgeColor','interp','FaceColor','none','LineWidth',2,PlotOptions{:});
  end
end

function h=PlotSubTh2simp3D(self,u,PlotOptions)
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  view(3)
  if fc_tools.comp.isOctave()
    v=U(self.me);
    V=mean(v,1);
    h=patch('Vertices',self.q','Faces',self.me','CData',V,'FaceColor','interp',PlotOptions{:});
  else
    h=patch('Vertices',self.q','Faces',self.me','CData',U,'FaceColor','interp',PlotOptions{:});%'FaceColor','interp');%,'FaceColor','none','LineWidth',2)
  end
end

function h=PlotSubTh1simp3D(self,u,PlotOptions)
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  view(3)
  %patch('Vertices',self.q','Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none','EdgeAlpha',0.3,PlotOptions{:})
  h=patch('Vertices',self.q','Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none',PlotOptions{:});
end

function h=PlotSubTh2simp2D(self,u,PlotOptions)
  global plan
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    assert(length(u)==self.nq);
    U=u;
  end
  if plan
    if fc_tools.comp.isOctave()
      v=U(self.me);
      V=mean(v,1);
      h=patch('Vertices',self.q','Faces',self.me','CData',V,'FaceColor','interp',PlotOptions{:});
    else
      h=patch('Vertices',self.q','Faces',self.me','CData',U,'FaceColor','interp',PlotOptions{:});
    end
  else
    h=trisurf(self.me',self.q(1,:),self.q(2,:),U,PlotOptions{:});
  end
end

function h=PlotSubTh1simp2D(self,u,PlotOptions)
  global plan
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    %assert(length(u)==self.nq);
    U=u;
  end
  % in 3d
%    if (length(u)==self.nq)
%      patch('Vertices',[self.q',U],'Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none','LineWidth',2,PlotOptions{:})
%    else
%      % FC : 17/02/2016, 
%      patch('Vertices',self.q','Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none','LineWidth',2,PlotOptions{:})
%    end
  
  if plan   % FC : 24/04/2016, 
    h=patch('Vertices',self.q','Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none','LineWidth',2,PlotOptions{:});
  else
    h=patch('Vertices',[self.q',U],'Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none','LineWidth',2,PlotOptions{:});
  end
end

function h=PlotSubTh1simp1D(self,u,PlotOptions)
  if length(u)==self.nqGlobal
    U=u(self.toGlobal);
  elseif length(u)==self.nqParent
    U=u(self.toParent);
  else
    %assert(length(u)==self.nq);
    U=u;
  end
  [qs,Ind]=sort(self.q);
  h=plot(qs,U(Ind),PlotOptions{:});
%  line(self.q',U',PlotOptions{:}) % version precedente - pas ok si ordre quelconque des sommets dans q
%    %patch('Vertices',self.q','Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none','LineWidth',2)
%    % in 3d
%    if (length(u)==self.nq)
%      patch('Vertices',[self.q',U],'Faces',self.me','CData',U,'EdgeColor','interp','FaceColor','none','LineWidth',2,PlotOptions{:})
%    else
%      patch('Vertices',[self.q'],'Faces',self.me','CData',U,'EdgeColor','none','FaceColor','interp','LineWidth',2,PlotOptions{:})
%    end
end
